Index: /XIOS/dev/dev_olga/src/node/interpolate_domain.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/interpolate_domain.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/node/interpolate_domain.hpp	(revision 1021)
@@ -50,5 +50,5 @@
       virtual ~CInterpolateDomain(void);
 
-      virtual void checkValid(CDomain* axisDest);
+      virtual void checkValid(CDomain* domainSource);
 
       /// Accesseurs statiques ///
Index: /XIOS/dev/dev_olga/src/node/variable.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/variable.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/node/variable.cpp	(revision 1021)
@@ -127,20 +127,18 @@
    }
 
-   void CVariable::sendValue(const int srvPool)
-   {
-     CContext* context=CContext::getCurrent() ;
-     CContextClient* contextClientTmp = context->clientPrimServer[srvPool];
+   void CVariable::sendValue(CContextClient* client)
+   {
      CEventClient event(this->getType(),EVENT_ID_VARIABLE_VALUE) ;
-     if (contextClientTmp->isServerLeader())
+     if (client->isServerLeader())
      {
        CMessage msg ;
        msg<<this->getId() ;
        msg<<content ;
-       const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
+       const std::list<int>& ranks = client->getRanksServerLeader();
        for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
          event.push(*itRank,1,msg);
-       contextClientTmp->sendEvent(event) ;
+       client->sendEvent(event) ;
      }
-     else contextClientTmp->sendEvent(event) ;
+     else client->sendEvent(event) ;
    }
 
Index: /XIOS/dev/dev_olga/src/node/variable.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/variable.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/node/variable.hpp	(revision 1021)
@@ -79,5 +79,5 @@
             //! Sending a request to set up variable data
             void sendValue();
-            void sendValue(const int srvPool);
+            void sendValue(CContextClient* client);
 
             static void recvValue(CEventServer& event) ;
Index: /XIOS/dev/dev_olga/src/object_template.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/object_template.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/object_template.hpp	(revision 1021)
@@ -9,4 +9,5 @@
 #include "event_server.hpp"
 #include "attribute.hpp"
+#include "context_client.hpp"
 
 namespace xios
@@ -56,11 +57,11 @@
          std::map<int, size_t> getMinimumBufferSizeForAttributes();
          void sendAttributToServer(const string& id);
-         void sendAttributToServer(const string& id, const int srvPool);
+         void sendAttributToServer(const string& id, CContextClient* client);
          void sendAttributToServer(CAttribute& attr) ;
-         void sendAttributToServer(CAttribute& attr, const int srvPool) ;
+         void sendAttributToServer(CAttribute& attr, CContextClient* client) ;
          void sendAllAttributesToServer();
-         void sendAllAttributesToServer(const int srvPool);
+         void sendAllAttributesToServer(CContextClient* client);
          void sendAddItem(const string& id, int itemType);
-         void sendAddItem(const string& id, int itemType, const int srvPool);
+         void sendAddItem(const string& id, int itemType, CContextClient* client);
          static void recvAttributFromClient(CEventServer& event) ;
          static bool dispatchEvent(CEventServer& event) ;
Index: /XIOS/dev/dev_olga/src/object_template_impl.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/object_template_impl.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/object_template_impl.hpp	(revision 1021)
@@ -164,9 +164,6 @@
    std::map<int, size_t> CObjectTemplate<T>::getMinimumBufferSizeForAttributes()
    {
-     // CContextClient* client = CContext::getCurrent()->client;
+     // Use correct context client to send message
      CContext* context = CContext::getCurrent();
-
-          // Use correct context client to send message
-//     CContextClient* contextClientTmp = (0 != context->clientPrimServer) ? context->clientPrimServer : context->client;
      int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
      for (int i = 0; i < nbSrvPools; ++i)
@@ -244,5 +241,5 @@
 
    template<typename T>
-   void CObjectTemplate<T>::sendAllAttributesToServer(const int srvPool)
+   void CObjectTemplate<T>::sendAllAttributesToServer(CContextClient* client)
    {
      CAttributeMap& attrMap = *this;
@@ -250,5 +247,5 @@
      for (; it != itE; ++it)
      {
-       if (!(it->second)->isEmpty()) sendAttributToServer(*(it->second), srvPool);
+       if (!(it->second)->isEmpty()) sendAttributToServer(*(it->second), client);
      }
    }
@@ -263,9 +260,9 @@
 
    template <class T>
-   void CObjectTemplate<T>::sendAttributToServer(const string& id, const int srvPool)
+   void CObjectTemplate<T>::sendAttributToServer(const string& id, CContextClient* client)
    {
       CAttributeMap & attrMap = *this;
       CAttribute* attr=attrMap[id];
-      sendAttributToServer(*attr, srvPool);
+      sendAttributToServer(*attr, client);
    }
 
@@ -273,8 +270,6 @@
   void CObjectTemplate<T>::sendAttributToServer(CAttribute& attr)
   {
+     // Use correct context client to send message
     CContext* context=CContext::getCurrent();
-
-     // Use correct context client to send message
-//    CContextClient* contextClientTmp = (0 != context->clientPrimServer) ? context->clientPrimServer : context->client;
     if (context->hasClient)
     {
@@ -283,18 +278,9 @@
       {
         CContextClient* contextClientTmp = (context->hasServer) ? context->clientPrimServer[i] : context->client;
-        // CContextClient* contextClientTmp=context->contextClientTmp;
-
         CEventClient event(getType(),EVENT_ID_SEND_ATTRIBUTE);
         if (contextClientTmp->isServerLeader())
         {
           CMessage msg;
-//          if (context->hasServer)
-//          {
-//            StdString tmp = this->getIdServer() + "_" +boost::lexical_cast<string>(i);
-//            msg<<tmp;
-//          }
-//          else
-            msg<<this->getIdServer();
-
+          msg<<this->getIdServer();
           msg << attr.getName();
           msg << attr;
@@ -331,10 +317,8 @@
 
   template <class T>
-  void CObjectTemplate<T>::sendAttributToServer(CAttribute& attr, const int srvPool)
+  void CObjectTemplate<T>::sendAttributToServer(CAttribute& attr, CContextClient* client)
   {
-    CContext* context=CContext::getCurrent();
-    CContextClient* contextClientTmp = context->clientPrimServer[srvPool];
     CEventClient event(getType(),EVENT_ID_SEND_ATTRIBUTE);
-    if (contextClientTmp->isServerLeader())
+    if (client->isServerLeader())
     {
       CMessage msg;
@@ -342,12 +326,11 @@
       msg << attr.getName();
       msg << attr;
-      const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
+      const std::list<int>& ranks = client->getRanksServerLeader();
       for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
         event.push(*itRank,1,msg);
-      contextClientTmp->sendEvent(event);
+      client->sendEvent(event);
     }
-    else contextClientTmp->sendEvent(event);
+    else client->sendEvent(event);
   }
-
 
   /*!
@@ -364,6 +347,5 @@
     if (context->hasClient)
     {
-       // Use correct context client to send message
-//      CContextClient* contextClientTmp = (0 != context->clientPrimServer) ? context->clientPrimServer : context->client;
+      // Use correct context client to send message
       int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
       for (int i = 0; i < nbSrvPools; ++i)
@@ -387,22 +369,21 @@
 
   template<class T>
-  void CObjectTemplate<T>::sendAddItem(const StdString& id, int itemType, const int srvPool)
+  void CObjectTemplate<T>::sendAddItem(const StdString& id, int itemType, CContextClient* client)
   {
-    CContext* context = CContext::getCurrent();
     typedef typename T::EEventId ItemType;
-     CContextClient* contextClientTmp = context->clientPrimServer[srvPool];
      CEventClient event(this->getType(),ItemType(itemType));
-     if (contextClientTmp->isServerLeader())
+     if (client->isServerLeader())
      {
        CMessage msg;
        msg << this->getId();
        msg << id;
-       const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
+       const std::list<int>& ranks = client->getRanksServerLeader();
        for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
          event.push(*itRank,1,msg);
-       contextClientTmp->sendEvent(event);
+       client->sendEvent(event);
      }
-     else contextClientTmp->sendEvent(event);
+     else client->sendEvent(event);
   }
+
 
   template <class T>
Index: /XIOS/dev/dev_olga/src/server.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/server.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/server.cpp	(revision 1021)
@@ -22,9 +22,10 @@
     list<MPI_Comm> CServer::interComm ;
     std::list<MPI_Comm> CServer::contextInterComms;
-    int CServer::nbSndSrvPools = (CXios::serverLevel == 0) ? 0 : 1;
-    int CServer::poolNb = 0;
+    int CServer::serverLevel = 0 ;
+    int CServer::nbPools = 0;
+    int CServer::poolId = 0;
+    int CServer::serverSize = 0;
     bool CServer::isRoot = false ;
     int CServer::rank = INVALID_RANK;
-    int CServer::rankSndServers = 0;
     StdOFStream CServer::m_infoStream;
     StdOFStream CServer::m_errorStream;
@@ -37,5 +38,5 @@
 /*!
  * \fn void CServer::initialize(void)
- * Function creates intra and inter comm for each initialized server pool
+ * Creates intraComm and interComm for a server pool (primary or secondary).
  */
     void CServer::initialize(void)
@@ -46,5 +47,4 @@
       else is_MPI_Initialized=false ;
 
-
       // Not using OASIS
       if (!CXios::usingOasis)
@@ -58,10 +58,11 @@
 
         boost::hash<string> hashString ;
-        unsigned long hashServer1 = hashString(CXios::xiosCodeIdPrm);
-        unsigned long hashServer2 = hashString(CXios::xiosCodeIdSnd);
-        unsigned long hashServer = (CXios::serverLevel < 2)  ? hashServer1 : hashServer2;
+//        unsigned long hashServer1 = hashString(CXios::xiosCodeIdPrm);
+//        unsigned long hashServer2 = hashString(CXios::xiosCodeIdSnd);
+//        unsigned long hashServer = (CXios::serverLevel < 2)  ? hashServer1 : hashServer2;
+        unsigned long hashServer = hashString(CXios::xiosCodeId);
 
         unsigned long* hashAll ;
-        unsigned long* hashAllServers ;
+//        unsigned long* hashAllServers ;
 
 //        int rank ;
@@ -69,5 +70,5 @@
         int myColor ;
         int i,c ;
-        MPI_Comm newComm, serversInterComm;
+        MPI_Comm newComm, serversComm;
 
         MPI_Comm_size(CXios::globalComm, &size) ;
@@ -77,9 +78,7 @@
         MPI_Allgather(&hashServer, 1, MPI_LONG, hashAll, 1, MPI_LONG, CXios::globalComm) ;
 
-        map<unsigned long, int> colors, colorsServers ;
+        map<unsigned long, int> colors ;
         map<unsigned long, int> leaders ;
         map<unsigned long, int>::iterator it ;
-//        map<unsigned long, int> leadersServers ;
-        vector<int> leadersServers;
 
         for(i=0,c=0;i<size;i++)
@@ -93,75 +92,26 @@
         }
 
-        nbSndSrvPools = size - leaders[hashServer2];    // one proc per secondary-server pool
-
-        // Taking into account multiple pools on secondary server
-        if (nbSndSrvPools > 1)
-        {
-          if (CXios::serverLevel > 1)
+        // Setting the number of secondary pools
+        myColor = colors[hashServer];
+        if (CXios::usingServer2)
+        {
+          int serverRank = rank - leaders[hashServer]; // server proc rank starting 0
+          serverSize = size - leaders[hashServer];
+          nbPools = serverSize * CXios::ratioServer2 / 100;
+          if ( serverRank < (serverSize - nbPools) )
           {
-            int nbProcs = size - leaders[hashServer2];
-            int remain = nbProcs % nbSndSrvPools;
-            int procsPerPool = nbProcs / nbSndSrvPools;
-            rankSndServers = rank - leaders[hashServer2];
-            StdString strTmp = CXios::xiosCodeIdSnd;
-
-            if (remain == 0)
-            {
-              poolNb = rankSndServers/procsPerPool;
-            }
-            else
-            {
-              if (rankSndServers <= (procsPerPool + 1) * remain)
-                poolNb = rankSndServers/(procsPerPool+1);
-              else
-              {
-                poolNb = remain + 1;
-                rankSndServers -= (procsPerPool + 1) * remain;
-                rankSndServers -= procsPerPool;
-                poolNb += rankSndServers/procsPerPool;
-              }
-            }
-            strTmp += boost::lexical_cast<string>(poolNb+1);  // add 1 to avoid hashing zero
-            hashServer = hashString(strTmp);
-            hashServer2 = hashString(strTmp);
+            serverLevel = 1;
+          }
+          else
+          {
+            serverLevel = 2;
+            poolId = serverRank - serverSize + nbPools;
+            myColor = rank;
           }
         }
 
-        if (nbSndSrvPools > 1)
-        {
-          myColor = size;
-          MPI_Comm_split(MPI_COMM_WORLD, myColor, rank, &serversInterComm) ;
-        }
-        else
-        {
-          myColor=colors[hashServer] ;
-          MPI_Comm_split(MPI_COMM_WORLD, myColor, rank, &intraComm) ;
-        }
-
-        if (nbSndSrvPools > 1)
-        {
-          int sizeServers;
-//          int rankServers;
-//          MPI_Comm_rank(serversInterComm, &rankServers) ;
-          MPI_Comm_size(serversInterComm, &sizeServers) ;
-          hashAllServers=new unsigned long[sizeServers] ;
-          MPI_Allgather(&hashServer, 1, MPI_LONG, hashAllServers, 1, MPI_LONG, serversInterComm) ;
-
-          for(i=0, c=0; i<sizeServers; i++)
-          {
-            if (colorsServers.find(hashAllServers[i])==colorsServers.end())
-            {
-              colorsServers[hashAllServers[i]]=c ;
-//              leadersServers[hashAllServers[i]]= leaders[hashServer1] + i ;
-              leadersServers.push_back( leaders[hashServer1] + i );
-              c++ ;
-            }
-          }
-          myColor=colorsServers[hashServer] ;
-          MPI_Comm_split(serversInterComm, myColor, rank, &intraComm) ;
-        }
-
-
-        if (CXios::serverLevel == 0)
+        MPI_Comm_split(CXios::globalComm, myColor, rank, &intraComm) ;
+
+        if (serverLevel == 0)
         {
           int clientLeader;
@@ -183,114 +133,49 @@
           }
         }
-        else
-        {
-          if ((CXios::serverLevel == 1))
+        else if (serverLevel == 1)
+        {
+          int clientLeader, srvPrmLeader, srvSndLeader;
+          for (it=leaders.begin();it!=leaders.end();it++)
           {
-            // Creating interComm with client (interCommLeft)
-            int clientLeader;
-            int srvSndLeader;
-            for(it=leaders.begin();it!=leaders.end();it++)
+            if (it->first != hashServer)
             {
-              if (it->first != hashServer2)
-              {
-                if (it->first != hashServer1)
-                {
-                  clientLeader=it->second ;
-                  int intraCommSize, intraCommRank ;
-                  MPI_Comm_size(intraComm, &intraCommSize) ;
-                  MPI_Comm_rank(intraComm, &intraCommRank) ;
-                  info(50)<<"intercommCreate::server "<<rank<<" intraCommSize : "<<intraCommSize
-                           <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
-                  MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
-                  interCommLeft.push_back(newComm) ;
-                  interComm.push_back(newComm) ;
-                }
-              }
-              else
-              {
-                srvSndLeader = it->second;
-              }
-            }
-
-            // Creating interComm with secondary server pool(s) (interCommRight)
-//            if (nbSndSrvPools < 1)
-            if (nbSndSrvPools < 2)
-            {
-              CClient::initializeClientOnServer(rank, intraComm, srvSndLeader);
-              interCommRight.push_back(CClient::getInterComm());
-              interComm.push_back(CClient::getInterComm());
+              clientLeader=it->second ;
+              int intraCommSize, intraCommRank ;
+              MPI_Comm_size(intraComm, &intraCommSize) ;
+              MPI_Comm_rank(intraComm, &intraCommRank) ;
+              info(50)<<"intercommCreate::server "<<rank<<" intraCommSize : "<<intraCommSize
+                       <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
+              MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
+              interCommLeft.push_back(newComm) ;
+              interComm.push_back(newComm) ;
             }
             else
-            {
-//              for(it=leadersServers.begin();it!=leadersServers.end();it++)
-//              {
-//                if (it->first != hashServer)
-//                {
-//                  srvSndLeader = it->second;
-//                  CClient::initializeClientOnServer(rank, intraComm, srvSndLeader);
-//                  interCommRight.push_back(CClient::getInterComm());
-//                  interComm.push_back(CClient::getInterComm());
-//                }
-//              }
-
-              for(int i = 1; i < leadersServers.size(); ++i)
-              {
-                srvSndLeader = leadersServers[i];
-                CClient::initializeClientOnServer(rank, intraComm, srvSndLeader);
-                interCommRight.push_back(CClient::getInterComm());
-                interComm.push_back(CClient::getInterComm());
-              }
-            }
-          } // primary server
-
-          else // secondary server pool(s)
+              srvPrmLeader = it->second;
+          }
+
+          for (int i = 0; i < nbPools; ++i)
           {
-            int clientLeader;
-            if (nbSndSrvPools < 2)
-//            if (nbSndSrvPools < 1)
-            {
-              for(it=leaders.begin();it!=leaders.end();it++)
-              {
-                if (it->first == hashServer1)
-                {
-                  clientLeader=it->second ;
-                  int intraCommSize, intraCommRank ;
-                  MPI_Comm_size(intraComm, &intraCommSize) ;
-                  MPI_Comm_rank(intraComm, &intraCommRank) ;
-                  info(50)<<"intercommCreate::server "<<rank<<" intraCommSize : "<<intraCommSize
-                           <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
-
-                  MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
-                  interCommLeft.push_back(newComm) ;
-                  interComm.push_back(newComm) ;
-
-                  break;
-                }
-              }
-            }
-            else
-            {
-//              for(it=leadersServers.begin();it!=leadersServers.end();it++)
-              {
- //               if (it->first == hashServer1)
-                {
-//                  clientLeader=it->second ;
-                  clientLeader = leadersServers[0];
-                  int intraCommSize, intraCommRank ;
-                  MPI_Comm_size(intraComm, &intraCommSize) ;
-                  MPI_Comm_rank(intraComm, &intraCommRank) ;
-                  info(50)<<"intercommCreate::server "<<rank<<" intraCommSize : "<<intraCommSize
-                           <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
-
-                  MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
-                  interCommLeft.push_back(newComm) ;
-                  interComm.push_back(newComm) ;
-                }
-              }
-            }
-          } // secondary server
-        } // CXios::serverLevel != 0
-
-        if (nbSndSrvPools > 1) delete [] hashAllServers;
+            srvSndLeader = srvPrmLeader + serverSize - nbPools + i;
+//            CClient::initializeClientOnServer(rank, serversComm, srvSndLeader);
+            CClient::initializeClientOnServer(rank, intraComm, srvSndLeader);
+            interCommRight.push_back(CClient::getInterComm());
+            interComm.push_back(CClient::getInterComm());
+          }
+        } // primary server
+        else
+        {
+          int clientLeader;
+          clientLeader = leaders[hashString(CXios::xiosCodeId)];
+          int intraCommSize, intraCommRank ;
+          MPI_Comm_size(intraComm, &intraCommSize) ;
+          MPI_Comm_rank(intraComm, &intraCommRank) ;
+          info(50)<<"intercommCreate::server "<<rank<<" intraCommSize : "<<intraCommSize
+                   <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
+
+          MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
+          interCommLeft.push_back(newComm) ;
+          interComm.push_back(newComm) ;
+        } // secondary server
+
         delete [] hashAll ;
 
@@ -416,5 +301,4 @@
              {
                MPI_Send(&msg,1,MPI_INT,0,0,*itr) ;
-
 //               MPI_Comm_free(&(*itr));
 //               interCommRight.erase(itr) ;
@@ -612,8 +496,8 @@
        contextInterComms.push_back(contextInterComm);
 
-       if (CXios::serverLevel == 1)
+       if (serverLevel == 1)
        {
 //         CClient::registerContext(contextId, intraComm);
-         CClient::registerContextOnSrvPools(contextId, intraComm);
+         CClient::registerContextByClienOfServer(contextId, intraComm);
        }
 
@@ -657,5 +541,5 @@
       int numDigit = 0;
       int size = 0;
-      int mpiRank;
+      int id;
       MPI_Comm_size(CXios::globalComm, &size);
       while (size)
@@ -665,9 +549,14 @@
       }
 
-      if (nbSndSrvPools < 2)
-        mpiRank = getRank();
+      if (!CXios::usingServer2)
+        id = getRank();
       else
-        mpiRank = rankSndServers;
-      fileNameClient << fileName << "_" << std::setfill('0') << std::setw(numDigit) << mpiRank << ext;
+      {
+        if (serverLevel == 1)
+          id = getRank();
+        else
+          id = poolId;
+      }
+      fileNameClient << fileName << "_" << std::setfill('0') << std::setw(numDigit) << id << ext;
       fb->open(fileNameClient.str().c_str(), std::ios::out);
       if (!fb->is_open())
Index: /XIOS/dev/dev_olga/src/server.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/server.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/server.hpp	(revision 1021)
@@ -33,6 +33,8 @@
         static CEventScheduler* eventScheduler;
 
-        static int nbSndSrvPools;   // number of secondary server pools
-        static int poolNb;          // for secondary servers; stores the pool number
+        static int serverLevel ;
+
+//        static int nbSndSrvPools;   // number of secondary server pools
+//        static int poolNb;          // for secondary servers; stores the pool number
 
         struct contextMessage
@@ -68,5 +70,7 @@
       private:
         static int rank;
-        static int rankSndServers;
+        static int serverSize;  //!< Number of procs dedicated to server
+        static int nbPools;     //!< Number of secondary-server pools
+        static int poolId;      //!< ID of a secondary-server pool
         static StdOFStream m_infoStream;
         static StdOFStream m_errorStream;
Index: /XIOS/dev/dev_olga/src/transformation/domain_algorithm_interpolate.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/domain_algorithm_interpolate.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/transformation/domain_algorithm_interpolate.cpp	(revision 1021)
@@ -48,7 +48,40 @@
 
 CDomainAlgorithmInterpolate::CDomainAlgorithmInterpolate(CDomain* domainDestination, CDomain* domainSource, CInterpolateDomain* interpDomain)
-: CDomainAlgorithmTransformation(domainDestination, domainSource), interpDomain_(interpDomain)
-{
+: CDomainAlgorithmTransformation(domainDestination, domainSource), interpDomain_(interpDomain), writeToFile_(false), readFromFile_(false)
+{
+  CContext* context = CContext::getCurrent();
   interpDomain_->checkValid(domainSource);
+  fileToReadWrite_ = "xios_interpolation_weights_";
+
+  if (interpDomain_->weight_filename.isEmpty())
+  {
+    fileToReadWrite_ += context->getId() + "_" + 
+                    domainSource->getDomainOutputName() + "_" + 
+                    domainDestination->getDomainOutputName() + ".nc";    
+  }
+  else 
+    fileToReadWrite_ = interpDomain_->weight_filename;
+
+  ifstream f(fileToReadWrite_.c_str());  
+  switch (interpDomain_->mode)
+  {
+    case CInterpolateDomain::mode_attr::read:
+      readFromFile_ = true;      
+      break;
+    case CInterpolateDomain::mode_attr::compute:
+      readFromFile_ = false;
+      break;
+    case CInterpolateDomain::mode_attr::read_or_compute:      
+      if (!f.good())
+        readFromFile_ = false;
+      else
+        readFromFile_ = true;
+      break;
+    default:
+      break;
+  } 
+
+  writeToFile_ = interpDomain_->write_weight;  
+    
 }
 
@@ -351,4 +384,6 @@
   }
 
+  if (writeToFile_ && !readFromFile_)
+     writeRemapInfo(interpMapValue);
   exchangeRemapInfo(interpMapValue);
 
@@ -434,19 +469,21 @@
 void CDomainAlgorithmInterpolate::computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs)
 {
-  if (!interpDomain_->file.isEmpty())
+  if (readFromFile_ && !writeToFile_)  
     readRemapInfo();
   else
-    computeRemap();
+  {
+    computeRemap(); 
+  }
+}
+
+void CDomainAlgorithmInterpolate::writeRemapInfo(std::map<int,std::vector<std::pair<int,double> > >& interpMapValue)
+{  
+  writeInterpolationInfo(fileToReadWrite_, interpMapValue);
 }
 
 void CDomainAlgorithmInterpolate::readRemapInfo()
-{
-  CContext* context = CContext::getCurrent();
-  CContextClient* client=context->client;
-  int clientRank = client->clientRank;
-
-  std::string filename = interpDomain_->file.getValue();
+{  
   std::map<int,std::vector<std::pair<int,double> > > interpMapValue;
-  readInterpolationInfo(filename, interpMapValue);
+  readInterpolationInfo(fileToReadWrite_, interpMapValue);
 
   exchangeRemapInfo(interpMapValue);
@@ -637,4 +674,107 @@
   delete [] recvBuff;
 }
+ 
+/*! Redefined some functions of CONetCDF4 to make use of them */
+CDomainAlgorithmInterpolate::WriteNetCdf::WriteNetCdf(const StdString& filename, const MPI_Comm comm)
+  : CNc4DataOutput(filename, false, false, true, comm, false, true) {}
+int CDomainAlgorithmInterpolate::WriteNetCdf::addDimensionWrite(const StdString& name, 
+                                                                const StdSize size)
+{
+  CONetCDF4::addDimension(name, size);  
+}
+
+int CDomainAlgorithmInterpolate::WriteNetCdf::addVariableWrite(const StdString& name, nc_type type,
+                                                               const std::vector<StdString>& dim)
+{
+  CONetCDF4::addVariable(name, type, dim);
+}
+
+void CDomainAlgorithmInterpolate::WriteNetCdf::writeDataIndex(const CArray<int,1>& data, const StdString& name,
+                                                              bool collective, StdSize record,
+                                                              const std::vector<StdSize>* start,
+                                                              const std::vector<StdSize>* count)
+{
+  CONetCDF4::writeData<int,1>(data, name, collective, record, start, count);
+}
+
+void CDomainAlgorithmInterpolate::WriteNetCdf::writeDataIndex(const CArray<double,1>& data, const StdString& name,
+                                                              bool collective, StdSize record,
+                                                              const std::vector<StdSize>* start,
+                                                              const std::vector<StdSize>* count)
+{
+  CONetCDF4::writeData<double,1>(data, name, collective, record, start, count);
+}
+
+/*
+   Write interpolation weights into a file
+   \param [in] filename name of output file
+   \param interpMapValue mapping of global index of domain destination and domain source as well as the corresponding weight
+*/
+void CDomainAlgorithmInterpolate::writeInterpolationInfo(std::string& filename,
+                                                         std::map<int,std::vector<std::pair<int,double> > >& interpMapValue)
+{
+  CContext* context = CContext::getCurrent();
+  CContextClient* client=context->client;
+
+  size_t n_src = domainSrc_->ni_glo * domainSrc_->nj_glo;
+  size_t n_dst = domainDest_->ni_glo * domainDest_->nj_glo;
+
+  long localNbWeight = 0;
+  long globalNbWeight;
+  long startIndex;
+  typedef std::map<int,std::vector<std::pair<int,double> > > IndexRemap;
+  IndexRemap::iterator itb = interpMapValue.begin(), it,
+                       ite = interpMapValue.end();
+  for (it = itb; it!=ite; ++it)
+  {
+    localNbWeight += (it->second).size();
+  }
+
+  CArray<int,1> src_idx(localNbWeight);
+  CArray<int,1> dst_idx(localNbWeight);
+  CArray<double,1> weights(localNbWeight);
+
+  int index = 0;
+  for (it = itb; it !=ite; ++it)
+  {
+    std::vector<std::pair<int,double> >& tmp = it->second;
+    for (int idx = 0; idx < tmp.size(); ++idx)
+    {
+      dst_idx(index) = it->first + 1;
+      src_idx(index) = tmp[idx].first + 1;
+      weights(index) = tmp[idx].second;
+      ++index;
+    }    
+  }
+
+  MPI_Allreduce(&localNbWeight, &globalNbWeight, 1, MPI_LONG, MPI_SUM, client->intraComm);
+  MPI_Scan(&localNbWeight, &startIndex, 1, MPI_LONG, MPI_SUM, client->intraComm);
+  
+  std::vector<StdSize> start(1, startIndex - localNbWeight);
+  std::vector<StdSize> count(1, localNbWeight);
+
+  WriteNetCdf netCdfWriter(filename, client->intraComm);
+
+  // netCdfWriter = CONetCDF4(filename, false, false, true, client->intraComm, false);
+
+  // Define some dimensions
+  netCdfWriter.addDimensionWrite("n_src", n_src);
+  netCdfWriter.addDimensionWrite("n_dst", n_dst);
+  netCdfWriter.addDimensionWrite("n_weight", globalNbWeight);
+  
+  std::vector<StdString> dims(1,"n_weight");
+
+  // Add some variables
+  netCdfWriter.addVariableWrite("src_idx", NC_INT, dims);
+  netCdfWriter.addVariableWrite("dst_idx", NC_INT, dims);
+  netCdfWriter.addVariableWrite("weight", NC_DOUBLE, dims);
+
+  // // Write variables
+  netCdfWriter.writeDataIndex(src_idx, "src_idx", true, 0, &start, &count);
+  netCdfWriter.writeDataIndex(dst_idx, "dst_idx", true, 0, &start, &count);
+  netCdfWriter.writeDataIndex(weights, "weight", true, 0, &start, &count);
+
+  netCdfWriter.closeFile();
+}
 
 /*!
